/* $Id:  $ */
/*!
 * \file	crt0_sigma0_cpp.S
 * \brief	Startup code for simple L4 applications with cpp without L4env
 *
 * \date	16/08/2003
 * \author	Rudolf Weber <rw@infnet.verein.de>
 *              learned from crt0-stuff from
 *              	  Frank Mehnert <fm3@os.inf.tu-dresden.de>
 *
 * (c) 2003 after the terms of GNU General Public License 2
 */
#define __ASSEMBLY__
#include <l4/sys/compiler.h>
	
	.text

ENTRY(__crt_dummy__)
ENTRY(_start)
ENTRY(start)
	/* set up initial stack */
	leal	stack,%esp

	/* clear the base pointer so that stack backtraces will work */
	xorl	%ebp,%ebp
	
	/* call l4util's _main */
	pushl   %eax
        pushl   %ebx
	movl	%ebx, _mbi
        call    _main
	addl	$8,%esp

	/* call constructors */
	call    _init 
	
	/* call program's main */
        pushl   $_argv
        pushl   _argc
        call    main

	/* call destructors */
	call    _fini
	
	addl	$8,%esp

1:	/* fall asleep */
	xorl	%ecx,%ecx
	xorl	%eax,%eax
	movl	%eax,%ebp
	movl	%eax,%esi
	movl	%eax,%edi
	decl	%eax
	int	$0x30
        jmp     1b

#if 0
ENTRY(__main)
	ret
#endif

        /* MultiBoot header */
        .p2align(2)

ENTRY(_mb_header)
        .long   0x1BADB002	/* magic */
        .long   0		/* flags: we are ELF ... */
        .long   0 - 0x1BADB002	/* checksum */

	.bss 

ENTRY(_mbi)
	.space	4

	.space	(1024*64)
ENTRY(stack)

/* collection of the init-function
 *  The frame_dumy and the __do_global_ctors_aux are static,
 *  thus it is called wia the _init-Function.
 *  otherwise we had to chance the usual crtstuff.c 
 */	
	.section .init
	.type _init,@function
ENTRY(_init)
	push %ebp
	mov  %esp,%ebp

/* collection of the fini-function */
	.section .fini
	.type _init,@function
ENTRY(_fini)
	push %ebp
	mov  %esp,%ebp
