/* -*- Makefile -*- */
ENTRY(_start)

SECTIONS
{
  /* Read-only sections, merged into text segment: */
  .text :
  {
    _stext = .;
    *(.text .text.* .gnu.linkonce.t.*)
    KEEP (*(.init))
    KEEP (*(.fini))
    *(.rodata .rodata.* .gnu.linkonce.r.*)
  } = 0x9090

  _etext = .;
  PROVIDE (etext = .);

  /* Linux: exception section for uaccess mechanism */
  __ex_table :
  {
    *(__ex_table)
  }

  /* ensure that data starts at a new L4 page */
  . = ALIGN(0x1000);
  .data :
  {
    *(.data .data.* .gnu.linkonce.d.*)
    . = ALIGN(4);
    __l4env_initcall_start = .;
    KEEP (*(.l4env_initcall.init))
    __l4env_initcall_end = .;
  }
  .eh_frame : { KEEP (*(.eh_frame)) }
  .gcc_except_table : { *(.gcc_except_table) }
  .dynamic :  { *(.dynamic) }
  .ctors :
  {
    KEEP (*(SORT(.ctors.*)))
    KEEP (*(.ctors))
  }
  .dtors :
  {
    KEEP (*(SORT(.dtors.*)))
    KEEP (*(.dtors))
  }
  .got : { *(.got.plt) *(.got) }

  _edata  =  .;
  PROVIDE (edata = .);

  __bss_start = .;
  .bss       :
  {
   *(.dynbss)
   *(.bss .gnu.linkonce.b.*)
   *(COMMON)
  }
  _end = . ;
  PROVIDE (end = .);

  /* XXX Moved here to ensure that these sections are located _after_ the
   * text section. In the other case we would get program sections with a
   * virtual address of 0 */
  .hash    : { *(.hash)    }
  .dynsym  : { *(.dynsym)  }
  .dynstr  : { *(.dynstr)  }
  .rel.dyn : { *(.rel.dyn) }

  /* drop the following sections since we don't need them for DROPS */
  /DISCARD/ : {
    *(.interp)
    *(.comment)
    *(.note)
  }
}

